''' Python Function '''
def read_wrffields(folder, domain, year, variable, varadd):

    import os
    import numpy as np
    from netCDF4 import Dataset
    from wrf import to_np, getvar, smooth2d, get_cartopy, cartopy_xlim, cartopy_ylim, latlon_coords, ll_to_xy_proj, ll_to_xy, ALL_TIMES
    
    files = [i for i in os.listdir(folder) if os.path.isfile(os.path.join(folder,i)) \
                 and  'wrfout_'+domain+"_"+year+"-" in i]
    
    files_sorted = sorted(files, key=str.lower, reverse=False)
    for datafile in enumerate(files_sorted):
        wrflist = Dataset(folder+datafile[1])
        time = getvar(wrflist,"Times", timeidx = ALL_TIMES, method = "cat")
        hgt = getvar(wrflist, "z", timeidx = 0, method = "cat", meta = False)
        ter = getvar(wrflist, "ter", timeidx = 0, meta = False)
        latitudes = getvar(wrflist, "XLAT", timeidx = 0, method = "cat", meta = False)
        longitudes = getvar(wrflist, "XLONG", timeidx = 0, method = "cat", meta = False)
        print("here")
        var = getvar(wrflist, variable, timeidx = ALL_TIMES, method = "cat", meta = False)
        if(variable == "SNOWNC" or "SNOWNCvsSWE"):
            snownc = getvar(wrflist, variable, timeidx = ALL_TIMES, method = "cat", meta = False)
            graupelnc = getvar(wrflist, "GRAUPELNC", timeidx = ALL_TIMES, method = "cat", meta = False)
            var = snownc+graupelnc
            del snownc
            del graupelnc
        else:
            print("doch here")
            #var = getvar(wrflist, "uvmet10_wspd_wdir", timeidx = ALL_TIMES, method = "cat", meta = False)
        
        if (variable == "uvmet10"):
            if (np.shape(np.shape(var))[0] == 3):
                varhelp = var
                var = np.empty([2,1,np.shape(var)[1],np.shape(var)[2]])
                var[:,0,:,:] = np.asarray(varhelp[:,:,:])
        else:
            if (np.shape(np.shape(var))[0] == 2):
                varhelp = var
                var = np.empty([1,np.shape(var)[0],np.shape(var)[1]])
                var[0,:,:] = np.asarray(varhelp[:,:])
            

        if (datafile[1] == files_sorted[0]):
            timeseries = time
            varseries = var
        else:
            timeseries = np.append(timeseries,time)
            if (variable == "uvmet10"):
                print(np.shape(varseries))
                print(np.shape(var))
                varseries = np.append(varseries, var, axis = 1)
            else:
                varseries = np.append(varseries, var, axis = 0)
            del time
            del var
    del files
    del files_sorted
    del datafile
    del wrflist

    ## Remove duplicates
    print(np.shape(varseries))
    _, indices = np.unique(timeseries[:], return_index=True)
    timeseries_2 = timeseries[indices]
    if (variable == "uvmet10"):
        varseries_2 = varseries[:,indices,:,:]
    else:
        varseries_2 = varseries[indices,:,:]
    print(np.shape(varseries_2))
    del varseries
    del timeseries
    timeseries = np.array(timeseries_2, dtype='a29')
    #timeseries = timeseries_2
    varseries = varseries_2
    

    return [timeseries, varseries, hgt, ter, latitudes, longitudes]
